#include <stdlib.h>
#include <string.h>
#include "bmk.h"

static int Gint4(unsigned char *B,unsigned int *RV)
{
  *RV= B[0] | (B[1]<<8) | (B[2]<<16) | (B[3]<<24);
  return 4;
}

static int Gint1(unsigned char *B, unsigned char *RV)
{
  *RV= B[0];
  return 1;
}


static bmk_t *add_bookmark(bmk_t *parent, unsigned int type,
                           unsigned int page, unsigned char *title)
{
  bmk_t *B,*C;
  B= calloc(1,sizeof(*B));
  B->parent= parent;
  B->type= type;
  B->page= page;
  B->title= strdup((char*)title);
  if (parent->children) 
    C= parent->children;
  else
  {
    C= calloc(1,sizeof(*C));
    C->prev= C->next= C;
    C->parent= parent;
    parent->children= C;
  }
  B->prev= C->prev;
  B->next= C;
  C->prev->next= B;
  C->prev= B;
  return B;
}

bmk_t *bmk_decode(unsigned char *bdata,unsigned int sz)
{
  bmk_t *top, *current;
  unsigned char *T,*end,type;
  unsigned int K, bsz, page;

  end= bdata+sz;
  top= calloc(1,sizeof(*top));
  current= top;

  while(bdata<end)
  {
    K= 0;
    K+= Gint4(bdata+K, &bsz); 
    K+= Gint1(bdata+K, &type); 

    switch(type)
    {
    case 'B': K+= Gint4(bdata+K, &page);
              T= bdata+K;
              add_bookmark(current, type, page, T);
              break;
    case 'F': T= bdata+K;
              current= add_bookmark(current, type, 0, T);
              break;
    case 'E': if (current->parent) current= current->parent;
                              else goto done;
              break;
    }
    bdata+= bsz + 4;
  }
done:
  return top;
}
