static void set_fpos(FILE *f, unsigned int pos)
{
  if (fseek(f, pos, SEEK_SET))
    exit(fprintf(stderr,"can't seek in output file: %s\n",strerror(errno)));
}

static unsigned int get_fpos(FILE *f)
{
  long L;
  L= ftell(f);
  if (L<0)
    exit(fprintf(stderr,"can't get file position for output: %s\n",
            strerror(errno)));
  return L;
}

static void seek_end(FILE *f)
{
  if (fseek(f, 0, SEEK_END))
    exit(fprintf(stderr,"can't seek in output file: %s\n",strerror(errno)));
}

static void write_bytes(FILE *f, void *data, int len)
{
  int R;
  R= fwrite(data, 1, len, f);
  if (R!=len)
    exit(fprintf(stderr,"error writing to output\n"));
}

static int write_padding(FILE *f, int sz)
{
  static char zeros[1000];
  int O= sz;
  while(sz)
  {
    int cp;
    cp= sizeof(zeros);
    if (cp>sz) cp= sz;
    write_bytes(f,zeros, cp);
    sz-= cp;
  }
  return O;
}


